// Generated by CoffeeScript 1.7.1
(function() {
  var HTML_ESCAPE, HTML_ESCAPE_ONCE_REGEXP, HTML_ESCAPE_REGEXP, isString, toArray, toNumber, toObjectString, toString;

  toNumber = function(input) {
    return Number(input);
  };

  toObjectString = Object.prototype.toString;

  isString = function(input) {
    return toObjectString.call(input) === "[object String]";
  };

  toString = function(input) {
    if (input == null) {
      return "";
    } else if (isString(input)) {
      return input;
    } else if (typeof input.toString === "function") {
      return toString(input.toString());
    } else {
      return toObjectString.call(input);
    }
  };

  toArray = function(input) {
    if (Array.isArray(input)) {
      return input;
    } else {
      return [input];
    }
  };

  HTML_ESCAPE = function(chr) {
    switch (chr) {
      case "&":
        return '&amp;';
      case ">":
        return '&gt;';
      case "<":
        return '&lt;';
      case '"':
        return '&quot;';
      case "'":
        return '&#39;';
    }
  };

  HTML_ESCAPE_ONCE_REGEXP = /["><']|&(?!([a-zA-Z]+|(#\d+));)/g;

  HTML_ESCAPE_REGEXP = /([&><"'])/g;

  module.exports = {
    size: function(input) {
      var _ref;
      return (_ref = input != null ? input.length : void 0) != null ? _ref : 0;
    },
    downcase: function(input) {
      return toString(input).toLowerCase();
    },
    upcase: function(input) {
      return toString(input).toUpperCase();
    },
    append: function(input, suffix) {
      return toString(input) + toString(suffix);
    },
    prepend: function(input, prefix) {
      return toString(prefix) + toString(input);
    },
    empty: function(input) {
      if (!input) {
        return true;
      }
      if (input.length == null) {
        return false;
      }
      return true;
    },
    capitalize: function(input) {
      return toString(input).replace(/^([a-z])/, function(m, chr) {
        return chr.toUpperCase();
      });
    },
    sort: function(input, property) {
      if (property != null) {
        return toArray(input).sort(function(a, b) {
          var aValue, bValue, _ref, _ref1;
          aValue = a[property];
          bValue = b[property];
          return (_ref = aValue > bValue) != null ? _ref : {
            1: (_ref1 = aValue === bValue) != null ? _ref1 : {
              0: -1
            }
          };
        });
      } else {
        return toArray(input).sort();
      }
    },
    map: function(input, property) {
      return toArray(input).map(function(e) {
        if (property != null) {
          return e[property];
        } else {
          return e;
        }
      });
    },
    escape: function(input) {
      return toString(input).replace(HTML_ESCAPE_REGEXP, HTML_ESCAPE);
    },
    escape_once: function(input) {
      return toString(input).replace(HTML_ESCAPE_ONCE_REGEXP, HTML_ESCAPE);
    },
    strip_html: function(input) {
      return toString(input).replace(/<script[\s\S]*?<\/script>/g, "").replace(/<!--[\s\S]*?-->/g, "").replace(/<style[\s\S]*?<\/style>/g, "").replace(/<[^>]*?>/g, "");
    },
    strip_newlines: function(input) {
      return toString(input).replace(/\r?\n/g, "");
    },
    newline_to_br: function(input) {
      return toString(input).replace(/\n/g, "<br />\n");
    },
    replace: function(input, string, replacement) {
      if (replacement == null) {
        replacement = "";
      }
      return toString(input).replace(new RegExp(string, 'g'), replacement);
    },
    replace_first: function(input, string, replacement) {
      if (replacement == null) {
        replacement = "";
      }
      return toString(input).replace(string, replacement);
    },
    remove: function(input, string) {
      return this.replace(input, string);
    },
    remove_first: function(input, string) {
      return this.replace_first(input, string);
    },
    truncate: function(input, length, truncateString) {
      var l;
      if (length == null) {
        length = 50;
      }
      if (truncateString == null) {
        truncateString = '...';
      }
      input = toString(input);
      truncateString = toString(truncateString);
      if (input == null) {
        return;
      }
      if (!input.slice) {
        return;
      }
      length = toNumber(length);
      l = length - truncateString.length;
      if (l < 0) {
        l = 0;
      }
      if (input.length > length) {
        return input.slice(0, +l + 1 || 9e9) + truncateString;
      } else {
        return input;
      }
    },
    truncatewords: function(input, words, truncateString) {
      var l, wordlist;
      if (words == null) {
        words = 15;
      }
      if (truncateString == null) {
        truncateString = '...';
      }
      input = toString(input);
      if (input == null) {
        return;
      }
      if (!input.slice) {
        return;
      }
      wordlist = input.split(" ");
      words = toNumber(words);
      l = words - 1;
      if (l < 0) {
        l = 0;
      }
      if (wordlist.length > l) {
        return wordlist.slice(0, +l + 1 || 9e9).join(" ") + truncateString;
      } else {
        return input;
      }
    },
    split: function(input, pattern) {
      input = toString(input);
      if (!input) {
        return;
      }
      return input.split(pattern);
    },
    flatten: function(input) {
      return Liquid.Helpers.flatten(toArray(input));
    },
    join: function(input, glue) {
      if (glue == null) {
        glue = ' ';
      }
      return this.flatten(input).join(glue);
    },
    first: function(array) {
      if ((array != null ? array.length : void 0) > 0) {
        return array[0];
      } else {
        return null;
      }
    },
    last: function(array) {
      if ((array != null ? array.length : void 0) > 0) {
        return array[array.length - 1];
      } else {
        return null;
      }
    },
    plus: function(input, operand) {
      return toNumber(input) + toNumber(operand);
    },
    minus: function(input, operand) {
      return toNumber(input) - toNumber(operand);
    },
    times: function(input, operand) {
      return toNumber(input) * toNumber(operand);
    },
    dividedBy: function(input, operand) {
      return toNumber(input) / toNumber(operand);
    },
    divided_by: function(input, operand) {
      return this.dividedBy(input, operand);
    },
    modulo: function(input, operand) {
      return toNumber(input) % toNumber(operand);
    }
  };

}).call(this);

//# sourceMappingURL=standard_filters.map
